#include <fstream>
#include <cstring>
#define LGMAX 1004
#define INF 1000000000

using namespace std;
ifstream fin("farma.in");
ofstream fout("farma.out");
struct med
      {
        char nume[31];
        int pret;
      };
int suma, smin=INF;
int sol[10];
int solmin[10];
med a[10][10];
int n, cerinta;
int lg[10];
char s[LGMAX];
bool d[100][100];

void  citire();
void  sortare();
void  generare();
int verif();
int nr(char *s);
int cauta(char * s);
int det_suma();
int main()
{ int i;
  citire();
  if (cerinta==1)
     for (i=1; i<=n; i++) fout<<lg[i]<<'\n';
     else
     {
      generare();
      fout<<smin<<'\n';
      //for (i=1; i<=n; i++)  fout<<a[i][solmin[i]].nume<<' '<<a[i][solmin[i]].pret<<'\n';
     }
  fout.close();
  return 0;
}

void  citire()
{char c, *p;
 int i, poz1, poz2, m;
 fin>>cerinta>>n; fin.get(c);
 for (i=1; i<=n; i++)
     {
      fin.getline(s,LGMAX);
      p=strtok(s,":");
      do
      {
         p=strtok(NULL,", ");
         if (!p) break;
         strcpy(a[i][++lg[i]].nume,p);
         p=strtok(NULL,", ");
         a[i][lg[i]].pret=nr(p);
      }
      while (1);
     }
 sortare();
 fin>>m; fin.get(c);
 for (i=1; i<=m; i++)
      {fin.getline(s,LGMAX);
       p=strchr(s,'/');
       *p=NULL;
       poz1=cauta(s);
       poz2=cauta(p+1);
       d[poz1][poz2]=d[poz2][poz1]=1;
      }
 }


void  sortare()
//sortez medicamentele de pe fiecare linie crescator dupa pret
{int i, j, sch;
 med aux;
 for (i=1; i<=n; i++)
     {
       do
       {
           sch=0;
           for (j=1; j<lg[i]; j++)
               if (a[i][j].pret>a[i][j+1].pret)
                  {
                    aux=a[i][j]; a[i][j]=a[i][j+1]; a[i][j+1]=aux;
                    sch=1;
                  }
       }
       while (sch);
     }
}
void  generare()
{int i;
 for (i=1; i<=n; i++) sol[i]=1;
 while (1)
       {
         if (verif())
            {
              suma=det_suma();
              if (suma<smin)
                  {smin=suma;
                   for (i=1; i<=n; i++) solmin[i]=sol[i];
                  }
            }
         for (i=n; i>0 && sol[i]==lg[i]; i--) sol[i]=1;
         if (i==0) break;
            else sol[i]++;
       }
}

int verif()
{ int i, j;
  for (i=1; i<n; i++)
      for (j=i+1; j<=n; j++)
          if (d[i*10+sol[i]][j*10+sol[j]]) return 0;
  return 1;
}

int det_suma()
{int i, rez=0;
 for (i=1; i<=n; i++) rez+=a[i][sol[i]].pret;
 return rez;
}
int nr(char *s)
{int i, rez;
 for (rez=i=0; s[i]; i++)
      rez=rez*10+s[i]-'0';
 return rez;
}

int cauta(char * s)
{int i, j;
  for (i=1; i<=n; i++)
       for (j=1; j<=lg[i]; j++)
           if (!strcmp(s,a[i][j].nume)) return i*10+j;
  return 0;
}
