//Livia Toca
#include <iostream>
#include <fstream>
#include <cstring>
#include <stdlib.h>

using namespace std;
ofstream out("farma.out");
const int nrMaxSubstanteActive=10;
const int nrMaxMedicamente=10;
const int sumaMax=1000000;
struct tipMedicament
{
    char nume[31];
    int pret;
};

int combinatie[nrMaxSubstanteActive];
int nrMedicamente[nrMaxSubstanteActive]; //maximum 9 medicamente la fiecare substanta
int nrSubstanteActive;//maximum 9
int nrIncompatibilitati; //maximum 1400
tipMedicament lista[nrMaxSubstanteActive][nrMaxMedicamente];
int incompatibil[100][100];
int optiune;


int compare (const void * a, const void * b)
{
    tipMedicament ia,ib;
    ia=*(tipMedicament*)a;
    ib=*(tipMedicament*)b;
    if(ia.pret<ib.pret)
        return 0;
    return 1;
}

void adaugIncompatibilitate(char *med1,char *med2)
{
    int nrmed1,nrmed2;
    for(int i=1; i<=nrSubstanteActive; i++)
        for(int j=1; j<=nrMedicamente[i]; j++)
            if(!strcmp(lista[i][j].nume,med1))
            {
                nrmed1=i*10+j;
            }
            else if(!strcmp(lista[i][j].nume,med2))
            {
                nrmed2=i*10+j;
            }

     incompatibil[nrmed1][nrmed2]=incompatibil[nrmed2][nrmed1]=1;
}

void citire()
{
    ifstream in("farma.in");
    char linie[701], *cuv;
    in>>optiune>>nrSubstanteActive;
    in.get();
    for(int i=1; i<=nrSubstanteActive; i++)
    {
        in.get(linie,701);
        in.get();
        cuv=strtok(linie," :,");
        do
        {
            cuv=strtok(NULL," :,");
            if(cuv)
            {
                nrMedicamente[i]++;
                strcpy(lista[i][nrMedicamente[i]].nume,cuv);
                cuv=strtok(NULL, " :,");
                lista[i][nrMedicamente[i]].pret=atoi(cuv);
            }
        }
        while(cuv);
        qsort (lista[i], nrMedicamente[i]+1, sizeof(tipMedicament), compare);
    }
    in>>nrIncompatibilitati;
    if(nrIncompatibilitati)in.get();
    for(int i=1; i<=nrIncompatibilitati; i++)
    {
        in.get(linie,701);
        in.get();
        cuv=strtok(linie," /");
        cuv=strtok(NULL," /");
        adaugIncompatibilitate(linie,cuv);
    }
}

void afisareNumereMedicamente()
{
    for(int i=1;i<=nrSubstanteActive;i++)
        out<<nrMedicamente[i]<<endl;
}

void verificaMaiBun(int &sumaMin)
{
    int sp=0;
    for(int i=1;i<=nrSubstanteActive;i++)
        for(int j=1;j<i;j++)
            if(incompatibil[i*10+combinatie[i]][j*10+combinatie[j]])
                return;

    for(int i=1;i<=nrSubstanteActive;i++)
    {
         sp+=lista[i][combinatie[i]].pret;
         if(sp>sumaMin) return;
    }

    if(sp<sumaMin)
        sumaMin=sp;
}
void suma()
{
    int maiExista=1;
    int incaUna;
    int i;
    int sumaMin=sumaMax;
    for(i=1;i<nrSubstanteActive;i++)
        combinatie[i]=1;
    combinatie[nrSubstanteActive]=1;

    while(maiExista)
    {
        i=nrSubstanteActive;
        incaUna=0;
        while(i>0 && !incaUna)
        {
            combinatie[i]++;
            if(combinatie[i]>nrMedicamente[i])
            {
                combinatie[i]=1;
                i--;
            }
            else
                incaUna=1;
        }

        verificaMaiBun(sumaMin);
        if(i==0)
            maiExista=0;
    }
    out<<sumaMin;
}

int main()
{
    citire();
    if(optiune==1)
        afisareNumereMedicamente();
    else
        suma();
    return 0;
}
